/****************************************************************************
*                   colutils.h
*
*  This module contains all defines, typedefs, and prototypes for colutils.cpp.
*
*  from Persistence of Vision(tm) Ray Tracer
*  Copyright 1996-2002 Persistence of Vision Team
*---------------------------------------------------------------------------
*  NOTICE: This source code file is provided so that users may experiment
*  with enhancements to POV-Ray and to port the software to platforms other
*  than those supported by the POV-Ray Team.  There are strict rules under
*  which you are permitted to use this file.  The rules are in the file
*  named POVLEGAL.DOC which should be distributed with this file.
*  If POVLEGAL.DOC is not available it may be found online at -
*
*    http://www.povray.org/povlegal.html.
*
* This program is based on the popular DKB raytracer version 2.12.
* DKBTrace was originally written by David K. Buck.
* DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
*
*##############################################################################
*  This file is part of MegaPOV, which is a modified and unofficial version of POV-Ray
*
* $RCSfile: colutils.h,v $
* $Revision: 1.4 $
* $Author: abx $
* $Log: colutils.h,v $
* Revision 1.4  2002/12/12 13:03:28  abx
* film exposure simulation patch included in sources
*
* Revision 1.3  2002/12/07 16:48:31  smellenbergh
* Adds listed pattern, displacement warp
* Header CVS keywords fix
*
* Revision 1.2  2002/11/14 12:15:54  abx
* PoPOV 0.3 core + windows
*
*
*****************************************************************************/


#ifndef COLUTILS_H
#define COLUTILS_H

void gamma_correct(COLOUR Colour);
#ifdef FILM_EXPOSURE_SIMULATION_PATCH
  void expose_color(COLOUR Color);
#endif
void extract_colors(COLOUR Colour, unsigned char *Red, unsigned char  *Green, unsigned char  *Blue, unsigned char  *Alpha, DBL *grey);

/* ------------------------------------------------------ */
/* small colour */
/* ------------------------------------------------------ */
typedef unsigned char SMALL_COLOUR [4];

void photonRgbe2colour(COLOUR c, SMALL_COLOUR rgbe);
void colour2photonRgbe(SMALL_COLOUR rgbe, COLOUR c);

#endif
